!--------------------
!  definition de la donne initiale
!--------------------

module mod_ci

  use mod_precision

contains

  function ci(x,y) result(f0)

    implicit none

    real(pr), dimension(:,:),intent(in) :: x,y
    real(pr), dimension(1:size(x,1),1:size(x,2)) :: f0
    integer :: i,j

    !--- exemple 1 : fonction caracteristique disque
    do i=1,size(x,1)
       do j=1,size(x,2)
          if (((x(i,j)-0.75_pr)**2+y(i,j)**2)>0.0625_pr**2) then
             f0(i,j)=0._pr
          else
             f0(i,j)=1._pr
          end if
       end do
    end do

!!$    !--- exemple 2 : fonction caracteristique disque
!!$    do i=1,size(x,1)
!!$       do j=1,size(x,2)
!!$          if (((x(i,j)-1.5_pr)**2+y(i,j)**2)>1._pr/8._pr**2) then
!!$             f0(i,j)=0._pr
!!$          else
!!$             f0(i,j)=1._pr
!!$          end if
!!$       end do
!!$    end do
!!$    !--- exemples 3 et 4: fonction caracteristique disque
!!$    do i=1,size(x,1)
!!$       do j=1,size(x,2)
!!$          if (((x(i,j)+2.0_pr)**2+y(i,j)**2)>(3._pr/16._pr)**2) then
!!$             f0(i,j)=0._pr
!!$          else
!!$             f0(i,j)=1._pr
!!$          end if
!!$       end do
!!$    end do
!!$    !--- exemple 5 : zero
!!$    f0=0._pr


  end function ci

end module mod_ci
